package com.objis.demostruts;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import org.apache.commons.beanutils.PropertyUtils;


/**
 * La classe <strong>Action</strong> de notre application "Hello".<p>
 * C'est le "Controleur" de l'architecture MVC Struts.
 *
 * @author Douglas MBIANDOU
 */

public final class HelloAction extends Action {

    /**
     * Traitement de la requte HTTP, et cration de la rponse HTTP associe
     * (ou forward  un autre composant web qui va la crer).
     * retourne une instance d'<code>ActionForward</code> dcrivant ou et comment
     * le conrle doit tre forward, ou <code>null</code> si la rponse a dja t rendue
     * 
     *
     * @param mapping l'ActionMapping utilise pour slectionner l'instance
     * @param actionForm l'optionel bean ActionForm pour cette requte
     * @param request requte HTTP traite
     * @param response Rponse HTTP  crer
     *
     * @exception Exception Si la logique mtier lance une exception
     */
    public ActionForward execute(ActionMapping mapping,
				                         ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
    throws Exception {



        /*
         * Cette acttion est excute 
         *
         * /hello.do  - Au chargement de la page initiale
         * - ou -
         * /hello.do?action=getName - lorsqu'on poste le fomulaire
         *
         */

        // Si c'est la premire fois, go straight to page
        String action = request.getParameter("action");
	      if (action == null) {
	          return (mapping.findForward("SayHello"));
        }

        // Les "messages" viennent du fichier ApplicationResources.properties
	     // MessageResources messages = getResources(request);

	      /*
         * Valide les paramtres de requte utilisateur
         * Note: Validation technique des champs ralise dans HelloForm.java
         *       validation mtier ralise dan HelloAction.java
         */
	      ActionErrors errors = new ActionErrors();
      	String person = (String)
            PropertyUtils.getSimpleProperty(form, "person");

        String badPerson = "Atilla";

        if (person.equals(badPerson)) {
            errors.add("person",
               new ActionMessage("com.objis.demostruts.dont.talk.to.atilla", badPerson ));
	          saveErrors(request, errors);
    	      return (new ActionForward(mapping.getInput()));
        }

        /*
         * Ayant reu et valid les donnes soumises ds la vue, 
         * on met  jour le modle,
         */
        HelloModel hm = new HelloModel();
        hm.setPerson(person);

	  // TODO : Sauvegarde en base de donnes des informations 
        hm.saveToPersistentStore();

        /*
         * S'il y avait un choix de composants Vue dpendant du statut du modle 
         * la dcision  faire pour l'affichage est ici. Dans ce cas, il y a un seul composant vue
         *
         * Nous passons les donnes au composants vue  travers des attributs de page, 
         * de requte, de session, ou de contexte de servlet
         * Dans ce cas, le primtre le plus appropri est contexte de requte car les 
         * donnes ne seront plus necesaires aprs que la vue ai t gnre.
         *
         * Constants.HELLO_KEY fournit une cl accessible  la fois par le 
	 * composant controleur (cad cette classe) et le composant Vue 
	 * (c.a.d. la page JSP  laquelle ns forwardons).
         */

      	request.setAttribute( Constants.HELLO_KEY, hm);

        // Supprimer le bean formulaire - pas besoin des valeurs  
        request.removeAttribute(mapping.getAttribute());

	      // faire suivre le control  page de succs
	      return (mapping.findForward("SayHello"));

    }
}
